#include <iostream>

#include "dbaConn.h"

using namespace std;

int main()
{
	try
	{
		// Connect to mysql server on this machine,
		// database is "test", username "osmith" and password is (helpfully/confusingly) "database" :)
		DBA::Credentials creds("localhost", 0, "test", "osmith", "database") ;

		DBA::MySQLConnection conn;

		conn.Connect(creds, true, true) ;

		cout << "Connected to the database" << endl ;

		const char statement[] = "SELECT NOW()" ;
		DBA::ResultSet rs(conn, sizeof(statement) - 1, statement) ;

		if ( !rs.HasRows() )
			throw std::runtime_error("Didn't get any rows from SELECT NOW()?") ;

		if ( !rs.FetchRow() )
			throw std::runtime_error("Couldn't FetchRow the result of SELECT NOW()?") ;

		cout << "Database time via operator[]: " << rs[0] << endl ;

		const char* time = NULL ;
		rs >> time ;
		if ( time == NULL )
			throw std::runtime_error("rs >> time gave NULL") ;

		cout << "Database time via >>: " << time << endl ;

		try
		{
			rs >> time ;
			throw std::runtime_error("Allowed me to do rs >> time again") ;
		}
		catch ( std::logic_error& e )
		{
			cout << "Got logic_error exception as expected" << endl ;
		}
		catch ( std::exception& e )
		{
			throw e ;
		}

		conn.Disconnect() ;

		cout << "Disconnected from the database" << endl ;
	}
	catch ( std::exception& e )
	{
		cout << "EXCEPTION: " << e.what() << endl ;
	}

    return 0;
}

